From f6797c682f4785bef0f28fce9eea360853d23524 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Apr 06 2017 23:29:35 +0000
Subject: [PATCH 813/1001] Add a config panel to view, add and delete members


---

diff --git a/hubs/models.py b/hubs/models.py
index 758a64f..d54dccd 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -123,9 +123,9 @@ class Association(BASE):
     role = sa.Column(sa.Enum(*roles), primary_key=True)
 
     user = relation("User", backref=backref(
-        'associations', cascade="all, delete"))
+        'associations', cascade="all, delete, delete-orphan"))
     hub = relation("Hub", backref=backref(
-        'associations', cascade="all, delete"))
+        'associations', cascade="all, delete, delete-orphan"))
 
     @classmethod
     def get(cls, hub, user, role):
diff --git a/hubs/static/client/app/core/HubConfig.jsx b/hubs/static/client/app/core/HubConfig.jsx
index 73cbc7a..f4b75af 100644
--- a/hubs/static/client/app/core/HubConfig.jsx
+++ b/hubs/static/client/app/core/HubConfig.jsx
@@ -7,6 +7,7 @@ import {
 import {
   GeneralPanel,
   ChatPanel,
+  UserPanel,
   NotImplementedPanel,
   } from './HubConfigPanel.jsx';
 import TabSet from '../components/TabSet.jsx';
@@ -56,13 +57,15 @@ export default class HubConfig extends React.Component {
     this.state = {
       hubConfig: {},
       generalConfig: {},
+      users: {owner: [], member: []},
       dirty: false,
       mustReload: false,  // the settings were changed at least once
       error: null,
       loading: false
-    }
+    };
     this.serverRequest = null;
     this.handleChange = this.handleChange.bind(this);
+    this.handleUserChange = this.handleUserChange.bind(this);
     this.loadState = this.loadState.bind(this);
     this.pushState = this.pushState.bind(this);
   }
@@ -73,21 +76,31 @@ export default class HubConfig extends React.Component {
       dataType: 'json',
       cache: false,
       success: function(data) {
-        this.setState({
-          hubConfig: data.result.hub,
-          generalConfig: data.result.general,
-          dirty: false,
-          error: null,
-          loading: false
-        });
+        if (data.status === "OK") {
+          this.setState({
+            hubConfig: data.result.hubconfig,
+            generalConfig: data.result.general,
+            users: data.result.users,
+            dirty: false,
+            error: null,
+          });
+        } else if (data.status === "ERROR") {
+          this.setState({error: data.message});
+        } else {
+          this.setState({
+            error: "Unknown status: " + data.status
+          });
+        }
       }.bind(this),
       error: function(xhr, status, err) {
-        console.error(this.props.url, status, err.toString());
-        this.setState({
-          error: err.toString(),
-          loading: false
-        });
-      }.bind(this)
+        var msg = err.toString();
+        if (!msg) { msg = "Error communicating with the server"; }
+        console.error(this.props.url, status, msg);
+        this.setState({error: msg});
+      }.bind(this),
+      complete: function(xhr, status) {
+        this.setState({loading: false});
+      }.bind(this),
     }
   }
 
@@ -98,10 +111,11 @@ export default class HubConfig extends React.Component {
     this.serverRequest = $.ajax(params);
   }
 
-  pushState() {
+  pushState(data, category) {
     var params = this.getRequestParams();
     params.method = "POST";
-    params.data = this.state.hubConfig;
+    params.data = data;
+    params.url += "?category=" + category;
     this.setState({loading: true});
     this.serverRequest = $.ajax(params);
   }
@@ -115,10 +129,17 @@ export default class HubConfig extends React.Component {
       mustReload: true,
     }, function() {
       window.clearTimeout(this.pushTimer);
-      this.pushTimer = window.setTimeout(this.pushState, 1000);
+      this.pushTimer = window.setTimeout(
+        this.pushState, 1000, this.state.hubConfig, "config");
     });
   }
 
+  handleUserChange(username, role) {
+    console.log("new role", username, role);
+    var data = {username: username, role: role};
+    this.pushState(data, "role_change");
+  }
+
   componentDidMount() {
     this.loadState();
   }
@@ -129,7 +150,7 @@ export default class HubConfig extends React.Component {
       // The configuration was changed but the current display may not
       // reflect it (for example, the displayed summary may be the old one).
       // The only way to make the changes visible is to reload the page.
-      window.location = window.location;
+      window.location.reload(true);
     }
   }
 
@@ -138,7 +159,6 @@ export default class HubConfig extends React.Component {
       <IntlProvider locale={navigator.language}>
         <div className="modal-dialog modal-lg" role="document">
           <div className="modal-content">
-            <form method="post" action={this.props.url}>
               <div className="modal-header">
                 <button
                   type="button"
@@ -164,21 +184,34 @@ export default class HubConfig extends React.Component {
                       generalConfig={this.state.generalConfig}
                       tabTitle={<FormattedMessage {...messages.general} />}
                       handleChange={this.handleChange}
+                      loading={this.state.loading}
                       />
-                    <NotImplementedPanel
+                    <UserPanel
+                      users={this.state.users.owner}
+                      generalConfig={this.state.generalConfig}
+                      role="owner"
+                      handleChange={this.handleUserChange}
                       tabTitle={<FormattedMessage {...messages.owners} />}
+                      loading={this.state.loading}
                       />
-                    <NotImplementedPanel
+                    <UserPanel
+                      users={this.state.users.member}
+                      generalConfig={this.state.generalConfig}
+                      role="member"
+                      handleChange={this.handleUserChange}
                       tabTitle={<FormattedMessage {...messages.members} />}
+                      loading={this.state.loading}
                       />
                     <ChatPanel
                       hubConfig={this.state.hubConfig}
                       generalConfig={this.state.generalConfig}
                       tabTitle={<FormattedMessage {...messages.chat} />}
                       handleChange={this.handleChange}
+                      loading={this.state.loading}
                       />
                     <NotImplementedPanel
                       tabTitle={<FormattedMessage {...messages.other} />}
+                      loading={this.state.loading}
                       />
                   </TabSet>
                 </div>
@@ -190,7 +223,7 @@ export default class HubConfig extends React.Component {
                   ></span>
                 <button
                   type="button"
-                  className="btn btn-default"
+                  className="btn btn-secondary"
                   data-dismiss="modal"
                   disabled={this.state.dirty}
                   >
@@ -210,7 +243,6 @@ export default class HubConfig extends React.Component {
                   </div>
                 }
               </div>
-            </form>
           </div>
         </div>
       </IntlProvider>
diff --git a/hubs/static/client/app/core/HubConfigPanel.jsx b/hubs/static/client/app/core/HubConfigPanel.jsx
index ddc22d3..865e340 100644
--- a/hubs/static/client/app/core/HubConfigPanel.jsx
+++ b/hubs/static/client/app/core/HubConfigPanel.jsx
@@ -83,6 +83,34 @@ const messages = defineMessages({
     id: "hubs.core.config.chat.network",
     defaultMessage: "IRC network",
   },
+  users_fullname: {
+    id: "hubs.core.config.users.fullname",
+    defaultMessage: "Full name",
+  },
+  users_username: {
+    id: "hubs.core.config.users.username",
+    defaultMessage: "Username",
+  },
+  users_change_role: {
+    id: "hubs.core.config.users.change_role",
+    defaultMessage: "Change role",
+  },
+  users_na: {
+    id: "hubs.core.config.users.na",
+    defaultMessage: "(N/A)",
+  },
+  users_remove_user: {
+    id: "hubs.core.config.users.remove_user",
+    defaultMessage: "(remove user)",
+  },
+  users_add_user: {
+    id: "hubs.core.config.users.add_user",
+    defaultMessage: "Add user...",
+  },
+  users_add: {
+    id: "hubs.core.config.users.add",
+    defaultMessage: "Add",
+  },
 });
 
 
@@ -105,7 +133,7 @@ export class GeneralPanel extends React.Component {
     var stillLoading = (typeof this.props.hubConfig.summary === "undefined");
     var visibilities = this.props.generalConfig.hub_visibility || [];
     return (
-      <div>
+      <form onSubmit={(e) => {e.preventDefault();}}>
         <FormattedMessage {...messages.general_title} tagName="h3" />
         <FormattedMessage {...messages.general_intro} tagName="p" />
         <div className="form-group">
@@ -177,6 +205,112 @@ export class GeneralPanel extends React.Component {
             <FormattedMessage {...messages.general_avatar_help} />
           </p>
         </div>
+      </form>
+    );
+  }
+
+}
+
+
+export class UserPanel extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      addUsername: "",
+    };
+    this.handleAdd = this.handleAdd.bind(this);
+    this.handleAddInputChange = this.handleAddInputChange.bind(this);
+    this.handleChange = this.handleChange.bind(this);
+  }
+
+  handleAdd(e) {
+    e.preventDefault();
+    this.props.handleChange(this.state.addUsername, this.props.role);
+    this.setState({addUsername: ""});
+  }
+
+  handleAddInputChange(e) {
+    this.setState({
+      addUsername: e.target.value,
+    });
+  }
+
+  handleChange(e) {
+    e.preventDefault();
+    this.props.handleChange(e.target.name, e.target.value);
+  }
+
+  render() {
+    var users = this.props.users.map(function(user) {
+      return (
+        <tr key={user.username}>
+          <td>{user.fullname}</td>
+          <td>{user.username}</td>
+          <td>
+            {user.locked ?
+              <FormattedMessage {...messages.users_na} />
+            :
+              <select
+                name={user.username}
+                value={user.role}
+                className="form-control"
+                onChange={this.handleChange}
+                disabled={this.props.loading}
+                >
+                {this.props.generalConfig.roles.map(function(role) {
+                  return (
+                    <option value={role} key={role}>{role}</option>
+                    );
+                })}
+                <FormattedMessage {...messages.users_remove_user}>
+                  {(value) => ( <option value="">{value}</option> )}
+                </FormattedMessage>
+              </select>
+            }
+          </td>
+        </tr>
+        );
+    }.bind(this));
+
+    return (
+      <div>
+        <h3>{this.props.tabTitle}</h3>
+        <p className="text-muted">[Membership requests will be shown here]</p>
+        <hr />
+        <form className="form-inline" onSubmit={this.handleAdd}
+              style={{marginBottom: "1em"}}>
+          <div className="form-group">
+            <FormattedMessage {...messages.users_add_user}>
+              {(value) => (
+                <input
+                  type="text" className="form-control"
+                  name="username" placeholder={value}
+                  onChange={this.handleAddInputChange}
+                  value={this.state.addUsername}
+                  style={{marginRight: "1em"}}
+                  />
+                )}
+            </FormattedMessage>
+          </div>
+          <button className="btn btn-primary" disabled={this.props.loading}>
+            <FormattedMessage {...messages.users_add} />
+          </button>
+        </form>
+        {users.length !== 0 &&
+        <table className="table table-hover table-sm">
+          <thead>
+            <tr>
+              <FormattedMessage {...messages.users_fullname} tagName="th" />
+              <FormattedMessage {...messages.users_username} tagName="th" />
+              <FormattedMessage {...messages.users_change_role} tagName="th" />
+            </tr>
+          </thead>
+          <tbody>
+            {users}
+          </tbody>
+        </table>
+        }
       </div>
     );
   }
@@ -210,7 +344,7 @@ export class ChatPanel extends React.Component {
     }
 
     return (
-      <div>
+      <form onSubmit={(e) => {e.preventDefault();}}>
         <FormattedMessage {...messages.chat_title} tagName="h3" />
         <FormattedMessage {...messages.chat_intro_1} tagName="p" />
         <FormattedMessage {...messages.chat_intro_2} tagName="p" />
@@ -244,7 +378,7 @@ export class ChatPanel extends React.Component {
             {networks}
           </select>
         </div>
-      </div>
+      </form>
     );
   }
 
diff --git a/hubs/tests/test_fedora_hubs_flask_api.py b/hubs/tests/test_fedora_hubs_flask_api.py
index 778ea54..29b91fc 100644
--- a/hubs/tests/test_fedora_hubs_flask_api.py
+++ b/hubs/tests/test_fedora_hubs_flask_api.py
@@ -401,7 +401,7 @@ class HubsAPITest(hubs.tests.APPTest):
 
     def test_hub_config_get(self):
         expected = {
-            "hub": {
+            "hubconfig": {
                 "summary": "Ralph",
                 "left_width": 8,
                 "avatar": (
@@ -414,6 +414,16 @@ class HubsAPITest(hubs.tests.APPTest):
             },
             "general": {
                 "chat_networks": app.config["CHAT_NETWORKS"],
+                "roles": ["owner", "member"],
+            },
+            "users": {
+                "member": [],
+                "owner": [{
+                    "fullname": "Ralph",
+                    "locked": True,
+                    "role": "owner",
+                    "username": "ralph",
+                }],
             },
         }
         user = tests.FakeAuthorization('ralph')
@@ -428,7 +438,7 @@ class HubsAPITest(hubs.tests.APPTest):
     def test_hub_config_post(self):
         user = tests.FakeAuthorization('ralph')
         with tests.auth_set(app, user):
-            url = '/ralph/config'
+            url = '/ralph/config?category=config'
             result = self.app.post(url, data={
                 "summary": "changed value",
                 "chat_domain": "",
@@ -437,19 +447,19 @@ class HubsAPITest(hubs.tests.APPTest):
         result_data = json.loads(result.get_data(as_text=True))
         self.assertEqual(result_data["status"], "OK")
         self.assertEqual(
-            result_data["result"]["hub"]["summary"],
+            result_data["result"]["hubconfig"]["summary"],
             "changed value")
         self.assertEqual(
-            result_data["result"]["hub"]["chat_domain"],
+            result_data["result"]["hubconfig"]["chat_domain"],
             app.config["CHAT_NETWORKS"][0]["domain"])
 
     def test_hub_config_post_unknown_post_data(self):
         # Unknown POST data is silently ignored
         user = tests.FakeAuthorization('ralph')
         with tests.auth_set(app, user):
-            url = '/ralph/config'
+            url = '/ralph/config?category=config'
             result = self.app.post(url, data={"non_existant": "dummy"})
-        self.assertEqual(result.status_code, 400)
+        self.assertEqual(result.status_code, 200)
         result_data = json.loads(result.get_data(as_text=True))
         self.assertEqual(result_data["status"], "ERROR")
         self.assertEqual(result_data["message"], "Invalid value(s)")
@@ -462,9 +472,9 @@ class HubsAPITest(hubs.tests.APPTest):
     def test_hub_config_post_invalid_chat_domain(self):
         user = tests.FakeAuthorization('ralph')
         with tests.auth_set(app, user):
-            url = '/ralph/config'
+            url = '/ralph/config?category=config'
             result = self.app.post(url, data={"chat_domain": "dummy"})
-        self.assertEqual(result.status_code, 400)
+        self.assertEqual(result.status_code, 200)
         result_data = json.loads(result.get_data(as_text=True))
         self.assertEqual(result_data["status"], "ERROR")
         self.assertEqual(result_data["message"], "Invalid value(s)")
@@ -478,6 +488,6 @@ class HubsAPITest(hubs.tests.APPTest):
     def test_hub_config_unauthorized(self):
         user = tests.FakeAuthorization('ralph')
         with tests.auth_set(app, user):
-            url = '/decause/config'
+            url = '/decause/config?category=config'
             result = self.app.post(url, data={"summary": "Defaced!"})
         self.assertEqual(result.status_code, 403)
diff --git a/hubs/views/hub.py b/hubs/views/hub.py
index 75b5764..c3ea5f4 100644
--- a/hubs/views/hub.py
+++ b/hubs/views/hub.py
@@ -153,45 +153,96 @@ def hub_edit_post(hub):
 @require_hub_access("config", json=True)
 def hub_config(name):
     hub = get_hub(name)
-    config = {
+    if flask.request.method == 'POST':
+        category = flask.request.args["category"]
+        if category == "config":
+            result = hub_config_post_config(hub)
+        if category == "role_change":
+            result = hub_config_post_role_change(hub)
+        if result is not None:
+            return result
+    result = hub_config_get(hub)
+    return flask.jsonify(result)
+
+
+def hub_config_get(hub):
+    roles = ["owner", "member"]
+    result = {
         "status": "OK",
         "result": {
-            "hub": {},
+            "hubconfig": hub.config.__json__(),
             "general": {
                 "chat_networks": app.config["CHAT_NETWORKS"],
                 "hub_visibility": hubs.models.HubConfig.VISIBILITY,
+                "roles": roles,
             },
+            "users": {role: [] for role in roles},
         },
     }
-    if flask.request.method == 'POST':
-        # Validate values
-        def _validate_chat_domain(value):
-            valid_chat_domains = [
-                network["domain"] for network in app.config["CHAT_NETWORKS"]
-                ]
-            if not value and len(valid_chat_domains) > 0:
-                value = valid_chat_domains[0]
-            if value not in valid_chat_domains:
-                raise ValueError("Unsupported chat domain.")
-            return value
-        validator = RequestValidator(dict(
-            # Only allow the parameters listed in __json__().
-            (key, None) for key in hub.config.__json__().keys()
-        ))
-        validator.converters["chat_domain"] = _validate_chat_domain
-        try:
-            values = validator(flask.request.form)
-        except ValueError as e:
-            config = {"status": "ERROR", "message": "Invalid value(s)"}
-            config["fields"] = e.args[0]
-            return flask.jsonify(config), 400
-        # Now set the configuration values
-        for key, value in values.items():
-            setattr(hub.config, key, value)
-        try:
-            flask.g.db.commit()
-        except Exception as err:
-            config = {"status": "ERROR", "message": str(err)}
-            return flask.jsonify(config), 400
-    config["result"]["hub"].update(hub.config.__json__())
-    return flask.jsonify(config)
+    for assoc in sorted(hub.associations, key=lambda a: a.user.username):
+        if assoc.role not in roles:
+            continue
+        user = {
+            "username": assoc.user.username,
+            "fullname": assoc.user.fullname,
+            "role": assoc.role,
+        }
+        if (assoc.role == "owner" and
+                assoc.user.username == flask.g.auth.user.username):
+            user["locked"] = True
+        result["result"]["users"][assoc.role].append(user)
+    return result
+
+
+def hub_config_post_config(hub):
+    # Validate values
+    def _validate_chat_domain(value):
+        valid_chat_domains = [
+            network["domain"] for network in app.config["CHAT_NETWORKS"]
+            ]
+        if not value and len(valid_chat_domains) > 0:
+            value = valid_chat_domains[0]
+        if value not in valid_chat_domains:
+            raise ValueError("Unsupported chat domain.")
+        return value
+
+    validator = RequestValidator(dict(
+        # Only allow the parameters listed in __json__().
+        (key, None) for key in hub.config.__json__().keys()
+    ))
+    validator.converters["chat_domain"] = _validate_chat_domain
+    try:
+        values = validator(flask.request.form)
+    except ValueError as e:
+        result = {"status": "ERROR", "message": "Invalid value(s)"}
+        result["fields"] = e.args[0]
+        return flask.jsonify(result)
+
+    # Now set the configuration values
+    for key, value in values.items():
+        setattr(hub.config, key, value)
+    try:
+        flask.g.db.commit()
+    except Exception as err:
+        result = {"status": "ERROR", "message": str(err)}
+        return flask.jsonify(result)
+
+
+def hub_config_post_role_change(hub):
+    username = flask.request.form["username"]
+    user = hubs.models.User.get(username=username)
+    if user is None:
+        result = {
+            "status": "ERROR",
+            "fields": {"username": "Unknown user"},
+            "message": "Unknown user",
+            }
+        return flask.jsonify(result)
+    role = flask.request.form.get("role")
+    for assoc in hub.associations:
+        if assoc.hub == hub and assoc.user == user:
+            hub.associations.remove(assoc)
+    if role:
+        hub.associations.append(hubs.models.Association(
+            hub=hub, user=user, role=role))
+    flask.g.db.commit()
diff --git a/hubs/views/utils.py b/hubs/views/utils.py
index 0a89595..15ee71a 100644
--- a/hubs/views/utils.py
+++ b/hubs/views/utils.py
@@ -113,7 +113,12 @@ def configure_widget_instance(widget_instance):
     cur_config = cur_config.copy()
     cur_config.update(config)
     widget_instance.config = cur_config
-    # TODO: use a SQLAlchemy signal here
+    # Set the visibility parameter.
+    try:
+        widget_instance.visibility = flask.request.form["visibility"]
+    except KeyError:
+        pass  # the value is optional.
+    # Update the hub's mtime.  TODO: use a SQLAlchemy signal here.
     widget_instance.hub.last_edited = datetime.datetime.utcnow()
     try:
         flask.g.db.commit()

